/* Problem URL: https://codeforces.com/gym/104020/problem/F */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

#define double long double

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    string a, b;
    cin >> a >> b;

    double ang1;
    double ang2;

    map<string, double> var;
    var["N"] = 0;
    var["E"] = 90;
    var["S"] = 180;
    var["W"] = 270;
    var["NE"] = 45;
    var["SE"] = 135;
    var["SW"] = 225;
    var["NW"] = 315;

    if (a.size() == 1) {
        ang1 = var[a];
    } else {
        ang1 = var[a.substr(a.size() - 2)];

        map<char, double> mul;
        mul['W'] = 1;
        mul['E'] = 1;
        mul['S'] = 1;
        mul['N'] = 1;

        string tmp = a.substr(a.size() - 2);

        if (tmp == "NE") {
            mul['N'] = -1;
        } else if (tmp == "SE") {
            mul['E'] = -1;
        } else if (tmp == "SW") {
            mul['S'] = -1;
        } else {
            mul['W'] = -1;
        }

        a.pop_back();
        a.pop_back();

        double now = 45 / (double)2;

        while (!a.empty()) {
            ang1 += now * mul[a.back()];
            a.pop_back();
            now /= 2;
        }
    }

    if (b.size() == 1) {
        ang2 = var[b];
    } else {
        ang2 = var[b.substr(b.size() - 2)];

        map<char, double> mul;
        mul['W'] = 1;
        mul['E'] = 1;
        mul['S'] = 1;
        mul['N'] = 1;

        string tmp = b.substr(b.size() - 2);

        if (tmp == "NE") {
            mul['N'] = -1;
        } else if (tmp == "SE") {
            mul['E'] = -1;
        } else if (tmp == "SW") {
            mul['S'] = -1;
        } else {
            mul['W'] = -1;
        }

        b.pop_back();
        b.pop_back();

        double now = 45 / (double)2;

        while (!b.empty()) {
            ang2 += now * mul[b.back()];
            b.pop_back();
            now /= 2;
        }
    }

    if (ang1 < ang2) {
        swap(ang1, ang2);
    }

    cout << fixed << setprecision(20) << min(ang1 - ang2, (ang2 - ang1) + 360) << '\n';
}
